commit 1c092819de532ac599b055f4dae7422bbbaa03b5
Author: freddy77 <freddy77>
Date:   Tue Dec 15 11:46:39 2009 +0000

    Fix compile under Windows

diff --git a/ChangeLog b/ChangeLog
index 3b54ad5..5d10067 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Tue Dec 15 12:45:47 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/connectparams.c win32/winsetup.c:
+	- Fix compile under Windows
+
 Tue Dec 15 12:23:27 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c src/odbc/unittests/Makefile.am:
 	* src/odbc/unittests/common.h src/odbc/unittests/stats.c:
@@ -1991,4 +1995,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2907 2009/12/15 11:23:46 freddy77 Exp $
+$Id: ChangeLog,v 1.2908 2009/12/15 11:46:39 freddy77 Exp $
diff --git a/src/odbc/connectparams.c b/src/odbc/connectparams.c
index 99ead31..c9fbc49 100644
--- a/src/odbc/connectparams.c
+++ b/src/odbc/connectparams.c
@@ -37,7 +37,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: connectparams.c,v 1.79 2009/12/15 09:53:27 freddy77 Exp $");
+TDS_RCSID(var, "$Id: connectparams.c,v 1.80 2009/12/15 11:46:39 freddy77 Exp $");
 
 static const char odbc_param_Servername[] = "Servername";
 static const char odbc_param_Address[] = "Address";
@@ -118,7 +118,8 @@ parse_server(TDS_DBC *dbc, char *server, TDSCONNECTION * connection)
 
 	if (p) {
 		if (!tds_dstr_copy(&connection->instance_name, p+1)) {
-			odbc_errs_add(&dbc->errs, "HY001", NULL);
+			if (dbc)
+				odbc_errs_add(&dbc->errs, "HY001", NULL);
 			return 0;
 		}
 		*p = 0;
@@ -126,7 +127,8 @@ parse_server(TDS_DBC *dbc, char *server, TDSCONNECTION * connection)
 
 	tds_lookup_host(server, ip);
 	if (!tds_dstr_copy(&connection->ip_addr, ip)) {
-		odbc_errs_add(&dbc->errs, "HY001", NULL);
+		if (dbc)
+			odbc_errs_add(&dbc->errs, "HY001", NULL);
 		return 0;
 	}
 
@@ -158,11 +160,13 @@ odbc_get_dsn_info(TDS_DBC *dbc, const char *DSN, TDSCONNECTION * connection)
 		tds_dstr_copy(&connection->server_name, tmp);
 		tds_read_conf_file(connection, tmp);
 		if (myGetPrivateProfileString(DSN, odbc_param_Server, tmp) > 0) {
-			odbc_errs_add(&dbc->errs, "HY000", "You cannot specify both SERVERNAME and SERVER");
+			if (dbc)
+				odbc_errs_add(&dbc->errs, "HY000", "You cannot specify both SERVERNAME and SERVER");
 			return 0;
 		}
 		if (myGetPrivateProfileString(DSN, odbc_param_Address, tmp) > 0) {
-			odbc_errs_add(&dbc->errs, "HY000", "You cannot specify both SERVERNAME and ADDRESS");
+			if (dbc)
+				odbc_errs_add(&dbc->errs, "HY000", "You cannot specify both SERVERNAME and ADDRESS");
 			return 0;
 		}
 	}
@@ -281,7 +285,8 @@ odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *
 			end = connect_string_end;
 
 		if (!tds_dstr_copyn(&value, p, end - p)) {
-			odbc_errs_add(&dbc->errs, "HY001", NULL);
+			if (dbc)
+				odbc_errs_add(&dbc->errs, "HY001", NULL);
 			return 0;
 		}
 
@@ -289,7 +294,8 @@ odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *
 			/* error if servername or DSN specified */
 			if ((cfgs & (CFG_DSN|CFG_SERVERNAME)) != 0) {
 				tds_dstr_free(&value);
-				odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				if (dbc)
+					odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
 				return 0;
 			}
 			if (!cfgs) {
@@ -304,7 +310,8 @@ odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *
 		} else if (strcasecmp(option, "SERVERNAME") == 0) {
 			if ((cfgs & (CFG_DSN|CFG_SERVER)) != 0) {
 				tds_dstr_free(&value);
-				odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				if (dbc)
+					odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
 				return 0;
 			}
 			if (!cfgs) {
@@ -317,7 +324,8 @@ odbc_parse_connect_string(TDS_DBC *dbc, const char *connect_string, const char *
 		} else if (strcasecmp(option, "DSN") == 0) {
 			if ((cfgs & (CFG_SERVER|CFG_SERVERNAME)) != 0) {
 				tds_dstr_free(&value);
-				odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
+				if (dbc)
+					odbc_errs_add(&dbc->errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
 				return 0;
 			}
 			if (!cfgs) {
diff --git a/win32/winsetup.c b/win32/winsetup.c
index 6970710..b361af7 100644
--- a/win32/winsetup.c
+++ b/win32/winsetup.c
@@ -133,7 +133,7 @@ parse_wacky_dsn_string(LPCSTR attribs, DSNINFO * di)
 	}
 
 	/* let odbc_parse_connect_string() parse the ;-delimited version */
-	odbc_parse_connect_string(build, build + strlen(build), di->connection);
+	odbc_parse_connect_string(NULL, build, build + strlen(build), di->connection);
 }
 
 

